﻿;==============================================================================================================================================================================
; Universal, recursive search engine used by many functions
;==============================================================================================================================================================================

Procedure SearchEngine(SearchDirectory.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If SearchDirectory.s  <> "[ No BigOven CRB path set yet? ]"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearGadgetItems(#Gadget_BigOvenToSqLite_Recipeboxes)
    
    Program\Numberofrecipeboxes = 0
    
    SetGadgetText(#Gadget_BigOvenToSqLite_Numberofrecipeboxes, "Boxes found: "  + Str(Program\Numberofrecipeboxes))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearGadgetItems(#Gadget_BigOvenToSqLite_TItlelist)
    
    Program\Numberoftitles = 0
    
    SetGadgetText(#Gadget_BigOvenToSqLite_Numberoftitles, "Recipes found: "  + Str(Program\Numberofrecipeboxes))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    NewList FoundDirectories.s()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If SearchDirectory.s <> #EmptyString
      
      If Right(SearchDirectory.s, 1) = "\"
        
        SearchDirectory.s = Left(SearchDirectory.s, Len(SearchDirectory.s) - 1)
        
      EndIf
      
      AddElement(FoundDirectories.s())
      
      FoundDirectories.s() = SearchDirectory.s
      
      IndexLevel.i = 0
      
      Repeat
        
        SelectElement(FoundDirectories.s(), IndexLevel.i)
        
        If ExamineDirectory(0, FoundDirectories.s(), "*.*")
          
          Path.s = FoundDirectories.s() + "\"
          
          While NextDirectoryEntry(0)
            
            Filename.s = DirectoryEntryName(0)
            
            Select DirectoryEntryType(0)
  
              Case 1
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If LCase(GetExtensionPart(Path.s + Filename.s)) = "crb"
                  
                  Program\Numberofrecipeboxes + 1
                  
                  AddGadgetItem(#Gadget_BigOvenToSqLite_Recipeboxes, #AtTheEndOfTheList,  Filename.s)
                  
                  SetGadgetText(#Gadget_BigOvenToSqLite_Numberofrecipeboxes, "Boxes found: "  + Str(Program\Numberofrecipeboxes))
                  
                  While WindowEvent() : Wend
                
                  ConvertBigOvenToSqLite(Path.s + Filename.s)
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Case 2
                
                Filename.s = DirectoryEntryName(0)
                
                If Filename.s <> ".." And Filename.s <> "."
                  
                  AddElement(FoundDirectories())
                  
                  FoundDirectories() = Path + Filename.s
                  
                EndIf
                
            EndSelect
            
          Wend
          
        EndIf
        
        IndexLevel.i + 1
        
      Until IndexLevel.i > ListSize(FoundDirectories()) -1
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 17
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP