﻿;========================================================================================================================================================== 
; Temporary Ingredient list data structure
;==========================================================================================================================================================

Structure IngredientListStructure
  Column.i
  Measure.s
  Unit.s
  Ingredient.s
EndStructure

;================================================================================================================================================================================
; Format the ingredient string for mealmaster recipes
;================================================================================================================================================================================

Procedure ImportMealMasterIngredient(Column.i, Line.s, List IngredientList.IngredientListStructure())
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  AddElement(IngredientList())
  
  IngredientList()\Column       = Column
  
  IngredientList()\Measure      = Trim(Left(Line.s, 7))
  
  IngredientList()\Unit         = Trim(Mid(Line.s,  8, 3))
  
  IngredientList()\Ingredient   = Trim(Mid(Line.s, 12))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 11
; Folding = -
; EnableXP