﻿;==============================================================================================================================================================================
; Generic modules
;==============================================================================================================================================================================

Declare.s KillQuote(Instring.s)
Declare.s ProperCaseString(StringIn.s)
Declare.s RepQuote(Instring.s)
Declare.s TextToXML(TextString.s)
Declare.s XMLToText(XMLString.s)

;==============================================================================================================================================================================
; Database modules
;==============================================================================================================================================================================

Declare.s CorrectIngredientMeasure(MeasureString.s)                                         ; Correct single letter ingredient measure strings

;==============================================================================================================================================================================
; Database modules
;==============================================================================================================================================================================

Declare.s CountRecords(QueryString.s)
Declare.s DatabaseLastInsertRowId()
Declare   OpenSystemDatabase()

;==============================================================================================================================================================================
; Import modules
;==============================================================================================================================================================================

Declare   ImportFiles()

Declare   ClearRecipeStructure()
Declare.s RecipeCRLFSpaceTrim(RecipeString.s)

Declare.i ExtractFoodDateExchangeCompressedFile(ImportFileName.s)
Declare   ImportFoodDataExchangeCompressedFile(ImportFileName.s, DataFileName.s)
Declare   ImportFoodDataExchangeCompressedFile_XML(ImportFileName.s, DataFileName.s, *CurrentNode, CurrentSublevel.i)

Declare   ImportFoodDataExchangeFile(ImportFileName.s)
Declare   ImportFoodDataExchangeFile_XML(ImportFileName.s, *CurrentNode, CurrentSublevel.i)

Declare   ImportMasterCookIFile(ImportFileName.s)

Declare   ImportMasterCookIIFile(ImportFileName.s)
Declare   ImportMasterCookIIFile_XML(ImportFileName.s, *CurrentNode, CurrentSublevel.i)

Declare   ImportMealMasterFile(ImportFileName.s)
; Declare   ImportMealMasterIngredient(Column.i, Line.s, List IngredientList.IngredientListStructure())

Declare   ImportNowYoureCookingFile(ImportFileName.s)
Declare.s ImportNowYoureCookingIngredient(IngredientString.s)

Declare   ImportRecipeMLFile(ImportFileName.s)
Declare.i ImportRecipeMLFile_XML(ImportFileName.s, *CurrentNode, CurrentSublevel.i)

Declare   ImportBigOvenFile(ImportFilename.s)

Declare   SaveImportRecipe(ImportFileName.s)

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 14
; EnableAsm
; EnableUnicode
; EnableXP