﻿;==============================================================================================================================================================================
; Correct single letter ingredient measure strings
;==============================================================================================================================================================================

Procedure.s CorrectIngredientMeasure(MeasureString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select LCase(MeasureString.s)
      
    Case  "sl"                      : MeasureString.s = "Slice"
      
    Case  "c"                       : MeasureString.s = "Cup"
      
    Case  "g"                       : MeasureString.s = "Gram"
      
    Case  "gms"                     : MeasureString.s = "Grams"
      
    Case  "kg", "kil"               : MeasureString.s = "Kilogram"
      
    Case  "l"                       : MeasureString.s = "Litre"
      
    Case  "lb"                      : MeasureString.s = "Pound"
      
    Case  "ml"                      : MeasureString.s = "Millilitre"
      
    Case  "oz" 	                    : MeasureString.s = "Ounce"
      
    Case  "pt" 	                    : MeasureString.s = "Pint"
      
    Case  "pn" 	                    : MeasureString.s = "Pinch"
      
    Case  "ts" 	                    : MeasureString.s = "Teaspoon"
      
    Case  "tbsp" 	                  : MeasureString.s = "Tablespoon"
      
    Case  "cl"                      : MeasureString.s = "Clove"  
      
    Case  "lg"                      : MeasureString.s = "Large"  ; Large  
      
    Case  "bn"                      : MeasureString.s = "Bunch"
      
    Case  "ds"                      : MeasureString.s = "Dash"
      
    Case  "tb"                      : MeasureString.s = "Tub"
      
    Case  "doz"                     : MeasureString.s = "Dozen"
      
    Case  "gal"                     : MeasureString.s = "Gallons"
      
    Case  "pkg"                     : MeasureString.s = "Package"
      
    Case  "pk", "pkt"               : MeasureString.s = "Packet"
      
    Case  "qt"                      : MeasureString.s = "Quart"
      
    Case  "sm"                      : MeasureString.s = "Small"
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn MeasureString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 42
; FirstLine = 17
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP