;==============================================================================================================================================================================
; Strip illegal characters from text strings
;==============================================================================================================================================================================

Procedure.s XMLToText(XMLString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected TextString.s 
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  TextString.s = RemoveString(XMLString.s, #CR$)

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  If Left(TextString.s, 1) = #LF$

    TextString.s = Mid(TextString.s, 2)

  EndIf

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  TextString.s = ReplaceString(TextString.s, "&amp;",       "&")

  TextString.s = ReplaceString(TextString.s, "&lt;",        "<")

  TextString.s = ReplaceString(TextString.s, "&gt;",        ">")

  TextString.s = ReplaceString(TextString.s, "&apos;",      "'")

  TextString.s = ReplaceString(TextString.s, "&quot;",  #DQUOTE$)

  TextString.s = ReplaceString(TextString.s, "&#128",       "")

  TextString.s = ReplaceString(TextString.s, "&#39;",       "'")
  
  TextString.s = ReplaceString(TextString.s, #LF$, #EmptyString)

 ;TextString.s = ReplaceString(TextString.s, Chr(182),    #LF$))

  TextString.s = ReplaceString(TextString.s, #CR$, #EmptyString)

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn Trim(TextString.s)

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 50
; FirstLine = 17
; Folding = -
; EnableAsm
; EnableXP